// c    
//    (    )
// p.s. - 
// (c) Proteus 1:43 11.01.2008

#include<stdio.h>
#include<string.h>

typedef unsigned long  dword;
typedef unsigned short word;
typedef unsigned char  byte;

//  
#define POLYNOM8_1				0xD5
#define POLYNOM8_2				0xAB
#define POLYNOM8_3				0x57
#define POLYNOM8_ATM1			0x07				//(use: ATM HEC)	
#define POLYNOM8_ATM2			0xE0	
#define POLYNOM8_ATM3			0xC1
#define POLYNOM8_CCITT1			0x8D				//(use: 1-Wire bus)
#define POLYNOM8_CCITT2			0xB1
#define POLYNOM8_CCITT3			0x63
#define POLYNOM8_DALLAS1		0x31				//(use: 1-Wire bus)
#define POLYNOM8_DALLAS2		0x8C
#define POLYNOM8_DALLAS3		0x19
#define POLYNOM8_SAE1			0x1D
#define POLYNOM8_SAE2			0xB8

#define POLYNOM16_CCITT1		0x1021				//(X.25, V.41, Bluetooth, PPP, IrDA, BACnet; known as "CRC-CCITT")
#define POLYNOM16_CCITT2		0x8408
#define POLYNOM16_CCITT3		0x0811
#define POLYNOM16_IBM1			0x8005				//(XMODEM, USB, many others; also known as "CRC-16")
#define POLYNOM16_IBM2			0xA001	
#define POLYNOM16_IBM3			0x4003	

#define POLYNOM32_ZIP			0xEDB88320			//(ZIP)
#define POLYNOM32_MPEG2			0x04C11DB7			//(MPEG2)
#define POLYNOM32_MPEG2_1		POLYNOM_ZIP
#define POLYNOM32_MPEG2_2		0xDB710641
#define POLYNOM32_IEEE			POLYNOM_MPEG2 		//(IEEE 802.3)
#define POLYNOM32_IEEE_1		POLYNOM_ZIP
#define POLYNOM32_IEEE_2		POLYNOM_MPEG2_2
#define POLYNOM32_CASTAGNOLI1	0x1EDC6F41 			//(Castagnoli)
#define POLYNOM32_CASTAGNOLI2	0x82F63B78
#define POLYNOM32_Castagnoli3	0x05EC76F1
#define POLYNOM32_KOOPMAN1		0x741B8CD7 			//(Koopman)
#define POLYNOM32_KOOPMAN2		0xEB31D82E

#define POLYNOM64_ISO1			0x000000000000001B	//(ISO 3309)
#define POLYNOM64_ISO2			0xD800000000000000
#define POLYNOM64_ISO3			0xB000000000000001
#define POLYNOM64_ECMA1			0x42F0E1EBA9EA3693	//(ECMA-182)
#define POLYNOM64_ECMA2			0xC96C5795D7870F42
#define POLYNOM64_ECMA3			0x92D8AF2BAF0E1E85

// CC389320D42011282438822081A88121
const dword Polynom128[128/32]={0x81A88121,0x24388220,0xD4201128,0xCC389320};

// 82E2443E6320383A20B8A2A0A1EA91A3CCA99A30C5205038349C82AAA3A8FD27
const dword Polynom256[256/32]={0xA3A8FD27,0x349C82AA,0xC5205038,0xCCA99A30,0xA1EA91A3,0x20B8A2A0,0x6320383A,0x82E2443E};

//!     
//! Conversion<T1,T2>::check==true   T2     T1
template<class T,class U>
class Conversion{
	typedef char Small;
	class Big{char dummy[2];};
	static Small Test(const U&);
	static Big Test(...);
	static T MakeT();
public:
	enum {check=sizeof(Test(MakeT()))==sizeof(Small)};
};


//! ,       
//! SubClass<C1,C2>::check==TRUE   2   C1 
//! (        ,     )
template<class BASE,class CLS>
struct SubClass{
	enum{check=Conversion<const CLS*,const BASE*>::check };
};

//! ,  ,    
class BigNum_base{};


//!   . N -   (N<32 )
template<int N>
class BigNum:public BigNum_base{
	dword array[N/32];		//!<   (   )
	void Shift1();			//!<     
	void Shift8();			//!<    8 
	void Xor(BigNum<N>&);		//!<  
public:
	BigNum() {}
	BigNum(int v) {*this=v;};
	BigNum(const dword*);
	//  
	void operator =(int v) {
		if(v==-1) memset(array,-1,sizeof(array));
		else memset(array,0,sizeof(array)),array[0]=v;
	}
	void operator >>= (const int n) 	//   =const (  )
	{
		if(n==1) Shift1();
		if(n==8) Shift8();
	}
	bool operator != (BigNum<N>);
	void operator ^= (BigNum<N> &num) {Xor(num);}
	void operator ^= (byte v) {array[0]^=v;}
	int operator &(int n) {return array[0]&n;}
	operator int() {return array[0];}
	//  
	BigNum<N> &operator >> (int n) {return *this;}
	BigNum<N> &operator & (BigNum<N>) {return *this;}
};


template<int N>BigNum<N>::BigNum(const dword *data)
{
	memcpy(array,data,sizeof(array));
}

template<int N>void BigNum<N>::Xor(BigNum<N> &obj)
{
	int n;
	for(n=0; n<N/32; n++) array[n]^=obj.array[n];
}

template<int N>bool BigNum<N>::operator!=(BigNum<N> obj)
{
	return !!memcmp(array,obj.array,sizeof(array));
}



template<int N>void BigNum<N>::Shift1()
{
	dword b,c=0;
	int n=N/32;
	while(n) {
		n--;
		b=array[n]<<31;
		array[n]=(array[n]>>1)|c;
		c=b;
	}

}

template<int N>void BigNum<N>::Shift8()
{
	byte *b=(byte*)array;
	memcpy(b,b+1,N/8-1); b[N/8-1]=0;
}

//  NumCalc      .
// NumCalc<T,type> 
//    - T               .
//    - type=true        .


#if _MSC_VER<=1200	//        
//     Visual Studio C++ 6.0  
//    (   )

template<class T>struct NumCalc_{
	void operator ()(T &v,T &polynom){}
};
template<class T>struct NumCalc_big{
	void operator ()(T &v,T &polynom) {
		int n,b;
		for(n=0; n<8; n++) {
			b=v&1;
			v>>=1;
			if(b) v^=polynom;
		}
	}
};
template<class T>struct NumCalc_small{
	void operator ()(T &v,T &polynom) {
		for(int n=0;n<8;n++) v=v>>1^(-(int)(v&1)&polynom);
	}
};

template<bool b>struct NumCalc_Traits
{
	template<class T>struct _{typedef NumCalc_<T>Base;};
};

template<>struct NumCalc_Traits<true>
{
	template<class T>struct _{typedef NumCalc_big<T> Base;};
};

template<>struct NumCalc_Traits<false>
{
	template<class T>struct _{typedef NumCalc_small<T> Base;};
};

template<class T,bool b>
class NumCalc: public NumCalc_Traits<b>::template _<T>::Base {};

#else		//       

template<class T,bool>struct NumCalc{};	//     
template<class T>struct NumCalc<T,true>{	//    
	void operator ()(T &v,T &polynom) {
		int n,b;
		for(n=0; n<8; n++) {
			b=v&1;
			v>>=1;
			if(b) v^=polynom;
		}
	}
};
template<class T>struct NumCalc<T,false>{ //    
	void operator ()(T &v,T &polynom) {
		for(int n=0;n<8;n++) v=v>>1^(-(int)(v&1)&polynom);
	}
};
#endif

//!     
template<typename T>
class CRC {
	T crc_table[256];
public:
	CRC(T polynom);
	T Calc(byte*,size_t count);
};





template<typename T>
CRC<T>::CRC(T polynom)
{
	int n;
    NumCalc<T,SubClass<BigNum_base,T>::check> calc;	//   (    )
	for(n=0;n<256;n++) {
		crc_table[n]=n;
		calc(crc_table[n],polynom);
	}
}


template<typename T>
T CRC<T>::Calc(byte* data,size_t count)
{
	register byte b;
	T value=(dword)-1; 
	while(count--) {
		b=(byte)(int)value; value>>=8;
		value^=crc_table[b^*data++]; 
	}
	return value; 
}

//     (    5 )
template<typename T>
T _crc(byte *data,size_t count,T polynom) 
{
	T sum=(T)-1;
	NumCalc<T,SubClass<BigNum_base,T>::check> calc;	//   (    )
	while(count--) {
		sum^=*data++;
		calc(sum,polynom);
	}
	return sum;
}

// 
int main()
{
	size_t size;
	byte data[]="3,1415926535897932384626433832795";
//    
	if(sizeof(dword)!=4 || sizeof(word)!=2 || sizeof(byte)!=1) printf("type error\n\a"),getchar();
	CRC<dword> crc(POLYNOM32_ZIP);
	size=strlen((char*)data);
	if(crc.Calc(data,size)!=_crc(data,size,(dword)POLYNOM32_ZIP)) 
		printf("Internal error1\n\a"),getchar();
//    
	typedef BigNum<sizeof(Polynom128)*8> Num128;
	Num128 num128(Polynom128);
	CRC<Num128>crc128(num128);
	if(crc128.Calc(data,size)!=_crc(data,size,num128)) 
		printf("Internal error2\n\a"),getchar();

	typedef BigNum<sizeof(Polynom256)*8> Num256;
	Num256 num256(Polynom256);
	CRC<Num256>crc256(num256);
	if(crc256.Calc(data,size)!=_crc(data,size,num256)) 
		printf("Internal error3\n\a"),getchar();

	printf("done...\n");
	return 0;
}

